@echo off

@set UEFI_DUET=%CD%
@set DUET_BUILD=%2
@set EFI_BOOT_DISK=%1
@set DISK_LABEL=UEFI_DUET
@set PROCESSOR=X64 INTEL ICH10 (X58)
@set FILESYSTEM=FAT32

@set WIN_BIN_DIR=%UEFI_DUET%\Binaries
@set BOOTSECTOR_BIN_DIR=%UEFI_DUET%\BootSector
@set EFILDR_DIR=%UEFI_DUET%\Efildr\%DUET_BUILD%
@set BOOT_DIR=%UEFI_DUET%\EFI\Boot
@set TOOLS_DIR=%UEFI_DUET%\EFI\Tools
@set RAID_DIR=%UEFI_DUET%\EFI\Raid
@set REFIND_DIR=%UEFI_DUET%\Refind

@set DISKPART="NOTSET"

@if "%1"=="" goto Help
@goto Permissions

:Details 
@echo ------------------------------------------------------------------------------
@echo         Tianocore-UEFI-DUET FIRMWARE ARCH = %PROCESSOR%
@echo         Tianocore-UEFI-DUET FIRMWARE BUILD = %2
@echo         USB FLASH DRIVE = %1
@echo         USB FLASH DRIVE FILESYSTEM = %FILESYSTEM%
@echo ------------------------------------------------------------------------------

if "%2"=="CLEAN" (
		goto Diskpart_step0
    ) else if "%2"=="FORMAT" (
		goto CreateUSB_FAT32_step1
   ) else if "%2"=="DUET" (
		goto CreateUSB_FAT32_step2
   ) else if "%2"=="REFIND" (
		goto CreateUSB_FAT32_step3
   ) else (
        goto Help
   )	
 ))


:CreateUSB_FAT32_step1
@echo ------------------------------------------------------------------------------
@echo         Creating Tianocore UEFI DUET USB Boot disk...
@echo ------------------------------------------------------------------------------
@echo         Formatting %EFI_BOOT_DISK% as FAT32...
@echo.> FormatCommandInput.txt
@format /FS:%FILESYSTEM% /v:%DISK_LABEL% /q %EFI_BOOT_DISK% < FormatCommandInput.txt > NUL
@del FormatCommandInput.txt
@echo ------------------------------------------------------------------------------
@echo         %EFI_BOOT_DISK% Formatting Complete.
@echo ------------------------------------------------------------------------------
@echo         Setting up FAT32 boot sector...
@echo ------------------------------------------------------------------------------
@copy %BOOTSECTOR_BIN_DIR%\bs32.com %BOOTSECTOR_BIN_DIR%\bs32.com1
@%WIN_BIN_DIR%\Genbootsector.exe --verbose -i %EFI_BOOT_DISK% -o Usbbs32.com
@%WIN_BIN_DIR%\Bootsectimage.exe --verbose -g Usbbs32.com %BOOTSECTOR_BIN_DIR%\bs32.com1 -f
@del Usbbs32.com
@%WIN_BIN_DIR%\Genbootsector.exe --verbose -o %EFI_BOOT_DISK% -i %BOOTSECTOR_BIN_DIR%\bs32.com1 
@%WIN_BIN_DIR%\Genbootsector.exe --verbose --mbr -o %EFI_BOOT_DISK% -i %BOOTSECTOR_BIN_DIR%\Mbr.com 
@del %BOOTSECTOR_BIN_DIR%\bs32.com1
@echo ------------------------------------------------------------------------------
@echo         %EFI_BOOT_DISK% Setting boot sector Done.
@echo         UNPLUG USB, THEN PLUG IT AGAIN ( DO IT )
@echo ------------------------------------------------------------------------------
@goto end

:CreateUSB_FAT32_step2
@echo         Creating Tianocore UEFI DUET USB Boot disk...
@echo ------------------------------------------------------------------------------
@copy %EFILDR_DIR%\EfiLdr20 %EFI_BOOT_DISK%\Efildr20 /y
@mkdir %EFI_BOOT_DISK%\EFI
@mkdir %EFI_BOOT_DISK%\EFI\Boot
@mkdir %EFI_BOOT_DISK%\EFI\Raid
@copy %TOOLS_DIR%\shellx64.efi %EFI_BOOT_DISK%\EFI\Boot\Bootx64.efi /y
@copy %TOOLS_DIR%\*.nsh %EFI_BOOT_DISK%\EFI\Boot\ /y
@copy %RAID_DIR%\*.efi %EFI_BOOT_DISK%\EFI\Raid\ /y
@echo ------------------------------------------------------------------------------
@echo         %EFI_BOOT_DISK% %DUET_BUILD% Done.
@goto end

:CreateUSB_FAT32_step3
@echo         Creating Tianocore UEFI DUET USB Boot disk...
@echo ------------------------------------------------------------------------------
@mkdir %EFI_BOOT_DISK%\EFI\Tools
@mkdir %EFI_BOOT_DISK%\EFI\Boot\drivers
@mkdir %EFI_BOOT_DISK%\EFI\Boot\fonts
@mkdir %EFI_BOOT_DISK%\EFI\Boot\icons
@mkdir %EFI_BOOT_DISK%\EFI\Boot\themes\Min\icons
@copy %TOOLS_DIR%\shellx64.efi %EFI_BOOT_DISK%\EFI\Tools\shellx64.efi /y
@copy %REFIND_DIR%\refind.efi %EFI_BOOT_DISK%\EFI\Boot\Bootx64.efi /y
@copy %REFIND_DIR%\*.conf %EFI_BOOT_DISK%\EFI\Boot\ /y
@copy %REFIND_DIR%\drivers\*.efi %EFI_BOOT_DISK%\EFI\Boot\drivers /y
@copy %REFIND_DIR%\fonts\*.png %EFI_BOOT_DISK%\EFI\Boot\fonts /y
@copy %REFIND_DIR%\icons\*.png %EFI_BOOT_DISK%\EFI\Boot\icons /y
@copy %REFIND_DIR%\themes\Min\*.png %EFI_BOOT_DISK%\EFI\Boot\themes\Min\*.png /y
@copy %REFIND_DIR%\themes\Min\icons\*.png %EFI_BOOT_DISK%\EFI\Boot\themes\Min\icons\*.png /y
@echo ------------------------------------------------------------------------------
@echo         %EFI_BOOT_DISK% %DUET_BUILD% Done.
@goto end

:Permissions
    net session >nul 2>&1
    if %errorLevel% == 0 (
		@goto Details
    ) else (
        echo This script must be run as administrator.
    )
    goto End

:Help
@cls
@echo ------------------------------------------------------------------------------
@echo         The possible ARGUMENTS are: FORMAT ^| DUET ^| REFIND or CLEAN (in CAPS).
@echo(
@echo         DUET will copy DUET and the required file on the USB.
@echo         FORMAT will format and label the USB.
@echo         CLEAN will call diskpart and wipe and format the selected disk.
@echo         REFIND will copy REFIND and the required file on the USB.
@echo(
@echo         Usage : CreateUSB Drive_Letter: ARGUMENTS
@echo(
@echo         OPTIONAL : CreateUSB K: CLEAN ( see WARNINGS )
@echo(
@echo         STEP 1 : CreateUSB K: FORMAT
@echo         UNPLUG USB, THEN PLUG IT AGAIN ( DO IT )
@echo         STEP 2 : CreateUSB K: DUET
@echo(
@echo         OPTIONAL STEP 3: CreateUSB K: REFIND ( see README ) BOOT MANAGER
@echo(
@echo ------------------------------------------------------------------------------
goto end

:Diskpart_step0
@echo ------------------------------------------------------------------------------
@echo         The CLEAN command without user input is currently disabled.
@echo ------------------------------------------------------------------------------
goto :EOF

:Diskpart_step1
@cls
@echo ------------------------------------------------------------------------------
@echo         Tianocore-UEFI-DUET FIRMWARE ARCH = %PROCESSOR%
@echo         Tianocore-UEFI-DUET FIRMWARE BUILD = %2
@echo         USB FLASH DRIVE = %1
@echo ------------------------------------------------------------------------------
@echo(
@echo         WARNING!! BE SURE THE RIGHT VOLUME IS SELECTED.
@echo(
@echo         DISKPART will completely erase the selected partition table!
@echo(
@echo         SELECTED DRIVE IS = %EFI_BOOT_DISK%
@echo(
@echo         ARE YOU SURE TO CONTINUE?
@echo(
@echo         Be sure to select the USB Drive
@echo(
@echo         WARNING!!
@echo(
@echo         The next command will wipe the selected DISK w/o USER interaction!
@echo(
@echo         Setting Diskpart parameter... 
@echo(
@echo         TXT COMMAND is avaiable in CleanCommandInput.txt (DO NOT MODIFY)
@echo ------------------------------------------------------------------------------
@echo sel vol %EFI_BOOT_DISK% > CleanCommandInput.txt
@echo clean >> CleanCommandInput.txt
@echo convert mbr >> CleanCommandInput.txt
@echo create partition primary offset=1024 >> CleanCommandInput.txt
@echo format fs=fat32 quick >> CleanCommandInput.txt
@echo exit >> CleanCommandInput.txt
@set /P "DISKPART=Type AGREE (in CAPS) and press ENTER to proceed: "
if "%DISKPART%"=="CreateUSB.bat %EFI_BOOT_DISK% CLEAN"  (
    exit /B
    ) else if "%DISKPART%"=="CreateUSB %EFI_BOOT_DISK% CLEAN" (
	exit /B
    ) else if "%DISKPART%"=="AGREE" (
		goto Diskpart_step2
    ) else (
        goto :EOF
    )
))
@echo ------------------------------------------------------------------------------
goto end

:Diskpart_step2
@echo ------------------------------------------------------------------------------
@echo         Launching Diskpart...
@echo ------------------------------------------------------------------------------
@diskpart /s CleanCommandInput.txt
@del CleanCommandInput.txt
@echo ------------------------------------------------------------------------------
goto end

:End
@echo off
@exit /B
pause